function fnEnable( aEnable) {
  if (aEnable) {
    this.src = this.imNormal;
    this.onmouseover = fnOver;
    this.onmouseout = fnOut;
    this.onmousedown = fnDown;
    this.onmouseup = fnUp;
  } else {
    this.src = this.imDisable;
    this.onmouseover = null;
    this.onmouseout = null;
    this.onmousedown = null;
    this.onmouseup = null;
  }
  this.parentNode.style.pixelHeight = this.height;
}
function fnOver() {
  if (this.pressed) {
    this.src=this.imDown;
  } else {
    this.src=this.imOver;
  }
}
function fnOut() {
  this.src=this.imNormal;
}
function fnDown() {
  if (!this.pressed) {
    this.setCapture();
    this.src=this.imDown;
    this.pressed = true;
    _scrolingDir = this.direction;
    _scrolingObj = this.scrollObj;
    fnScrollingByStep();
    _scrolingTimer = setInterval( "fnScrollingByStep()", 200);
  }
}
function fnUp() {
  if (this.pressed) {
    this.releaseCapture();
    this.src =
      (event.offsetX < this.offsetWidth && event.offsetY < this.offsetHeight ?
        this.imOver : this.imNormal);
    this.pressed = false;
    clearInterval( _scrolingTimer);
    _scrolingObj = null;
  }
}

var _scrolingObj = null;
var _scrolingDir = 1;
var _scrolingTimer = 0;
function fnScrollingByStep() {
  if (_scrolingObj != null)
    _scrolingObj.setScrollPos(
      _scrolingObj.scrollPos + _scrolingObj.stepSize * _scrolingDir);
}

function fnThumbDown() {
  this.setCapture(); 
  this.pressedY = event.screenY;
  this.pressedThumbPos = this.scrollObj.thumb.style.posTop;
}
function fnThumbUp() {
  this.releaseCapture();
  this.pressedY = -1;
}
function fnThumbMove() {
  if (this.pressedY > -1) {
    this.scrollObj.moveThumb( this.pressedThumbPos + (event.screenY - this.pressedY));
  }
}
function fnTargetScroll() {
  this.scrollBar.updateFromTarget();
}

function ScrollBar( aTarget) {
  this.target = aTarget;
  aTarget.scrollBar = this;
  aTarget.style.pixelWidth = aTarget.offsetWidth - 13;
  this.ScrollBarElement = document.createElement( "table");

  this.ScrollBarElement.className = "clScroll";
  this.ScrollBarElement.border = 0;
  this.ScrollBarElement.cellSpacing = 0;
  this.ScrollBarElement.cellPadding = 0;
  this.ScrollBarElement.style.position = "absolute";
  this.ScrollBarElement.style.pixelHeight = aTarget.offsetHeight;
  this.ScrollBarElement.style.posTop = aTarget.offsetTop;
  this.ScrollBarElement.style.posLeft = aTarget.offsetLeft + aTarget.offsetWidth;

  this.upArrow = this.ScrollBarElement.insertRow().insertCell().insertBefore( new Image());
  this.upArrow.scrollObj = this;
  this.upArrow.pressed = false;
  this.upArrow.imNormal = this.upArrowNormal;
  this.upArrow.imDisable = this.upArrowDisable;
  this.upArrow.imOver = this.upArrowOver;
  this.upArrow.imDown = this.upArrowDown;
  this.upArrow.direction = -1;
  this.upArrow.setEnable = fnEnable;

  this.track = this.ScrollBarElement.insertRow().insertCell();
  this.track.vAlign = "top";
  this.track.style.backgroundImage = 'url( "' + this.trackBack + '")';

  this.thumb = document.createElement( "table");
  this.thumb.scrollObj = this;
  this.thumb.border = 0;                 
  this.thumb.cellSpacing = 0;            
  this.thumb.cellPadding = 0;            
  this.thumb.style.position = "relative";
  this.thumb.style.posTop = 0;
  this.thumb.style.posLeft = 0;
  this.thumb.pressedY = -1;
  this.thumb.onmousedown = fnThumbDown;
  this.thumb.onmouseup   = fnThumbUp;
  this.thumb.onmousemove = fnThumbMove;
  this.thumb.insertRow().insertCell().insertBefore( new Image()).src = this.thumbTop;
  this.thumb.insertRow().insertCell().style.backgroundImage = 'url( "' + this.thumbMedium + '")';
  this.thumb.insertRow().insertCell().insertBefore( new Image()).src = this.thumbBottom;
  this.track.insertBefore( this.thumb);

  this.downArrow = this.ScrollBarElement.insertRow().insertCell().insertBefore( new Image());
  this.downArrow.scrollObj = this;
  this.downArrow.pressed = false;
  this.downArrow.imNormal = this.downArrowNormal;
  this.downArrow.imDisable = this.downArrowDisable;
  this.downArrow.imOver = this.downArrowOver;
  this.downArrow.imDown = this.downArrowDown;
  this.downArrow.direction = 1;
  this.downArrow.setEnable = fnEnable;

  aTarget.offsetParent.insertBefore( this.ScrollBarElement, aTarget);

  this.updateFromTarget();
}

ScrollBar.prototype = new Object();
ScrollBar.prototype.upArrowNormal  = "upNormal.gif";
ScrollBar.prototype.upArrowOver    = "upOver.gif";
ScrollBar.prototype.upArrowDown    = "upDown.gif";
ScrollBar.prototype.upArrowDisable = "upDisable.gif";
ScrollBar.prototype.downArrowNormal  = "downNormal.gif";
ScrollBar.prototype.downArrowOver    = "downOver.gif";
ScrollBar.prototype.downArrowDown    = "downDown.gif";
ScrollBar.prototype.downArrowDisable = "downDisable.gif";
ScrollBar.prototype.thumbTop =    "thumbTop.gif";
ScrollBar.prototype.thumbMedium = "thumb.gif";
ScrollBar.prototype.thumbBottom = "thumbBottom.gif";
ScrollBar.prototype.trackBack = "track.gif";

ScrollBar.prototype.minPos = 0;
ScrollBar.prototype.maxPos = 100;
ScrollBar.prototype.scrollPos = 0;
ScrollBar.prototype.stepSize = 10;
ScrollBar.prototype.pageSize = 0;
ScrollBar.prototype.disabled = false;

function fnPropertyChange() {
  alert( 'onpropertychange: ' + window.event.propertyName);
  if (window.event.propertyName == 'scrollPos' ||
      window.event.propertyName == 'pageSize' ||
      window.event.propertyName == 'maxPos' ||
      window.event.propertyName == 'minPos' ||
      window.event.propertyName == 'disabled') {
    this.updateScrollBar();
  }
}

ScrollBar.prototype.setScrollRange = function( aMin, aMax, aPage, aStep) {
  this.minPos = aMin;
  this.maxPos = aMax;
  if (typeof( aPage) != 'undefined')  this.pageSize = aPage;
  if (typeof( aStep) != 'undefined')  this.stepSize = aStep;
  this.updateScrollBar();
}

ScrollBar.prototype.setScrollPos = function( aPos) {
  this.scrollPos = aPos;
  this.updateScrollBar();
}

ScrollBar.prototype.updateScrollBar = function( aOnScroll) {
  if (this.maxPos < this.minPos)     this.maxPos = this.minPos;
  if (this.scrollPos > this.maxPos)  this.scrollPos = this.maxPos;
  if (this.scrollPos < this.minPos)  this.scrollPos = this.minPos;
  var range = this.maxPos - this.minPos;
  if (this.pageSize > range)  this.pageSize = range;

  //if (range < trackSize)  range = 0;

  this.disabled = this.disabled || (range == 0);

  this.upArrow.setEnable( !this.disabled);
  this.downArrow.setEnable( !this.disabled);

  if (this.disabled) {
    this.thumb.style.display = 'none';
  } else {
    this.thumb.style.display = 'block';
    var pos = Math.min( this.scrollPos, this.maxPos - this.pageSize) - this.minPos;
    var trackSize = this.track.clientHeight -
      (this.thumb.cells( 0).offsetHeight + this.thumb.cells( 2).offsetHeight);
    var k = trackSize / range;
    var thumbSize = this.pageSize * k;
    this.thumb.cells( 1).style.pixelHeight = thumbSize;
    this.thumb.style.posTop = pos * k;
  }

  if ((typeof( aOnScroll) == 'undefined' || aOnScroll) &&
      typeof( this.onScroll) != 'undefined')
    this.onScroll();
}

ScrollBar.prototype.updateFromTarget = function() {
  this.minPos = 0;
  this.maxPos = this.target.scrollHeight;
  this.pageSize = this.target.clientHeight;
  this.scrollPos = this.target.scrollTop;
  this.updateScrollBar( false);
}

ScrollBar.prototype.moveThumb = function( pos) {
  var trackSize = this.track.clientHeight -
    (this.thumb.cells( 0).offsetHeight + this.thumb.cells( 2).offsetHeight);
  var k = trackSize / (this.maxPos - this.minPos);
  this.setScrollPos( pos / k);
}

ScrollBar.prototype.onScroll = function() {
  this.target.scrollTop = this.scrollPos;
  this.scrollPos = this.target.scrollTop;
}
